=== test/examples/t/read/CMakeLists.txt ===

add_test(NAME examples_read
         COMMAND osmium_read ${CMAKE_CURRENT_SOURCE_DIR}/data.osm)
