=== debian/changelog ===
libosmium (2.22.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.2, no changes.
  * Fix old FSF address in copyright file.
  * Mark libosmium2-doc as Multi-Arch: foreign.
  * Add upstream patch to fix FTBFS with CMake 4.x.
    (closes: #1113180)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Sep 2025 06:15:30 +0200

libosmium (2.22.0-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 18 Mar 2025 05:18:31 +0100
