=== debian/control ===
Source: libosmium
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               doxygen,
               cmake,
               graphviz,
               libboost-dev,
               libbz2-dev,
               libexpat1-dev,
               libgdal-dev,
               libgeos++-dev,
               liblz4-dev,
               libprotozero-dev (>= 1.6.3),
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/libosmium/
Vcs-Git: https://salsa.debian.org/debian-gis-team/libosmium.git
Homepage: https://osmcode.org/libosmium/
Rules-Requires-Root: no

Package: libosmium2-dev
Architecture: any
Section: libdevel
Depends: libboost-dev,
         libbz2-dev,
         libexpat1-dev,
         liblz4-dev,
         libprotozero-dev (>= 1.6.3),
         zlib1g-dev,
         ${misc:Depends}
Suggests: libosmium2-doc
Conflicts: libosmium-dev
Provides: libosmium-dev,
          libgdalcpp-dev
Replaces: libosmium-dev
Description: C++ framework for working with OSM data files
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.
 .
 Osmium is a header-only library, so there is nothing to compile to build it.
 Just include the header files you need.
 .
 This package contains the Osmium library headers.

Package: libosmium2-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: C++ framework for working with OSM data files - documentation
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.
 .
 Osmium is a header-only library, so there is nothing to compile to build it.
 Just include the header files you need.
 .
 This package contains the Osmium library documentation.
