=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Verbose make output
export VERBOSE=1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_GDALCPP=ON

override_dh_auto_build-arch:
	dh_auto_build --arch

override_dh_auto_build-indep:
	(cd build && $(MAKE) doc)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	(cd build && ctest -V)
endif

override_dh_auto_test-indep:
	# Skip tests when build-arch target was not executed

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

execute_after_dh_installdocs:
	# Remove useless autogenerated doxygen file
	$(RM) debian/*/usr/share/doc/*/html/*.md5
