## libosmium 2.23.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,27 @@
 #
 #-----------------------------------------------------------------------------
 
-cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.10)
+
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
+
+
+#-----------------------------------------------------------------------------
+#
+#  Decide which C++ version to use (Minimum/default: C++14)
+#
+#-----------------------------------------------------------------------------
+
+if(NOT USE_CPP_VERSION)
+    set(USE_CPP_VERSION 14)
+endif()
+message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
+
+set(CMAKE_CXX_STANDARD ${USE_CPP_VERSION})
+set(CMAKE_CXX_EXTENSIONS OFF)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 
 #-----------------------------------------------------------------------------
@@ -36,14 +55,7 @@
 #
 #-----------------------------------------------------------------------------
 
-project(libosmium)
-
-set(LIBOSMIUM_VERSION_MAJOR 2)
-set(LIBOSMIUM_VERSION_MINOR 22)
-set(LIBOSMIUM_VERSION_PATCH 0)
-
-set(LIBOSMIUM_VERSION
-    "${LIBOSMIUM_VERSION_MAJOR}.${LIBOSMIUM_VERSION_MINOR}.${LIBOSMIUM_VERSION_PATCH}")
+project(libosmium VERSION 2.23.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -152,7 +164,7 @@
 #
 #-----------------------------------------------------------------------------
 
-find_package(Boost 1.38)
+find_package(Boost CONFIG 1.38)
 mark_as_advanced(CLEAR BOOST_ROOT)
 
 if(Boost_FOUND)
@@ -181,27 +193,6 @@
 
 #-----------------------------------------------------------------------------
 #
-#  Decide which C++ version to use (Minimum/default: C++14).
-#
-#-----------------------------------------------------------------------------
-if(NOT MSVC)
-    if(NOT USE_CPP_VERSION)
-        if(CYGWIN)
-            set(USE_CPP_VERSION gnu++14)
-        else()
-            set(USE_CPP_VERSION c++14)
-        endif()
-    endif()
-    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
-    # following only available from cmake 2.8.12:
-    #   add_compile_options(-std=${USE_CPP_VERSION})
-    # so using this instead:
-    add_definitions(-std=${USE_CPP_VERSION})
-endif()
-
-
-#-----------------------------------------------------------------------------
-#
 #  Compiler and Linker flags
 #
 #-----------------------------------------------------------------------------
@@ -263,6 +254,10 @@
     endif()
     add_definitions(${OSMIUM_WARNING_OPTIONS})
 #    add_definitions(${OSMIUM_WARNING_OPTIONS} ${OSMIUM_DRACONIC_CLANG_OPTIONS} -Wno-documentation -Wno-format-nonliteral -Wno-deprecated -Wno-covered-switch-default -Wno-shadow)
+endif()
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    add_definitions(-Wno-stringop-overread -Wno-dangling-reference)
 endif()
 
 # Force RelWithDebInfo build type if none was given
@@ -322,7 +317,9 @@
         --quiet
         -j4
         --inline-suppr
-        --enable=warning,style,performance,portability,information,missingInclude
+        --suppress=duplInheritedMember
+        --enable=warning,style,performance,portability,information
+        --check-level=exhaustive
         --force
         -Uassert -DPROTOZERO_STRICT_API -DPROTOZERO_USE_BUILTIN_BSWAP -UPROTOZERO_USE_VIEW)
 
@@ -349,7 +346,7 @@
 
     add_custom_target(cppcheck
         ${CPPCHECK}
-        --std=c++14 ${CPPCHECK_OPTIONS}
+        --std=c++${USE_CPP_VERSION} ${CPPCHECK_OPTIONS}
         -I ${CMAKE_SOURCE_DIR}/include
         ${CPPCHECK_FILES}
     )
@@ -395,3 +392,5 @@
     file(MAKE_DIRECTORY header_check)
 
     foreach(hpp ${ALL_HPPS})
+        if((GDAL_FOUND) OR NOT ((hpp STREQUAL "osmium/area/problem_reporter_ogr.hpp") OR (hpp STREQUAL "osmium/geom/ogr.hpp")))
+            string(REPLACE ".hpp" "" tmp ${hpp})
