=== test/CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,7 @@
 add_unit_test(osm test_crc ENABLE_IF ${ZLIB_FOUND} LIBS ${ZLIB_LIBRARIES})
 add_unit_test(osm test_entity_bits)
 add_unit_test(osm test_location)
+add_unit_test(osm test_location_extra)
 add_unit_test(osm test_metadata)
 add_unit_test(osm test_node ENABLE_IF ${ZLIB_FOUND} LIBS ${ZLIB_LIBRARIES})
 add_unit_test(osm test_node_ref)
@@ -180,6 +181,7 @@
 add_unit_test(io test_output_utils)
 add_unit_test(io test_file_seek)
 add_unit_test(io test_string_table)
+add_unit_test(io test_print_width ENABLE_IF ${ZLIB_FOUND} LIBS ${ZLIB_LIBRARIES})
 
 add_unit_test(io test_bzip2 ENABLE_IF ${BZIP2_FOUND} LIBS ${BZIP2_LIBRARIES})
 add_unit_test(io test_gzip ENABLE_IF ${ZLIB_FOUND} LIBS ${ZLIB_LIBRARIES})
