=== debian/changelog ===
libosmium (2.23.0-2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.
  * Update branch in gbp.conf & Vcs-Git URL.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 30 Jan 2026 19:25:45 +0100

libosmium (2.23.0-2) unstable; urgency=medium

  * Drop support for 32-bit architectures, like other OSM tooling.
    https://github.com/osmcode/libosmium/issues/401

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jan 2026 19:31:29 +0100

libosmium (2.23.0-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Use debrebuild instead of reprotest.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Bump Standards-Version to 4.7.3, changes: priority.
  * Drop cmake-4.patch, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jan 2026 18:17:34 +0100
