=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Bas Couwenberg <sebastic@debian.org>
 Section: science
-Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: architecture-is-64-bit,
+               debhelper-compat (= 13),
                doxygen,
                cmake,
                graphviz,
@@ -15,11 +15,10 @@
                liblz4-dev,
                libprotozero-dev (>= 1.6.3),
                zlib1g-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libosmium/
-Vcs-Git: https://salsa.debian.org/debian-gis-team/libosmium.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/libosmium.git -b trixie-backports
 Homepage: https://osmcode.org/libosmium/
-Rules-Requires-Root: no
 
 Package: libosmium2-dev
 Architecture: any
